.comment comments *-------------------------------------------------------------*
|										|
|	MAG(16/256) Graphic Loader for over1024/512				|
|										|
|					original program by W-RINN		|
|					rewrited program by Herzen		|
|										|
|				--          based on MAGLD.S v1.10  --		|
|				-- modified for mag_load.has v2.00  --		|
comments *----------------------------------------------------------------------*

		.ifdef	PiH
			.include	pih.h
			.include	lib.h
			.xdef	header_read
			.xdef	decode
		.else
			.include	mph.h
			.include	mph_lib.h
		.endif

		.include	doscall.mac

		.xdef	mag_header_read__
		.xdef	mag_decode__

		.xref	skip_mac_binary
		.xref	getc
		.xref	getw
		.xref	comment_get

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* MAG(16/256)摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256Fɂ炸CPsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*
*----------------------------------------------------------------------------*

decode:
mag_decode__:
		movem.l	d3-d7/a3-a6,-(sp)
		cmp.w	#8,_color(a5)
		beq	mag_decode_256
		lea	magwork(pc),a6
		move.l	_buff_addr(a5),(a6)
		movea.l	a1,a0
		suba.l	#workend-header,a0
		bsr	pixel_decode
		movem.l	(sp)+,d3-d7/a3-a6
		rts

mag_decode_256:
		lea	magwork(pc),a6
	.ifdef PiH
		move.l	_buff_addr256(a5),(a6)
	.else
		move.l	_buff_addr(a5),(a6)
	.endif
		movea.l	a1,a0
		suba.l	#workend-header,a0
		bsr	pixel_decode
		movem.l	(sp)+,d3-d7/a3-a6
		rts


*----------------------------------------------------------------------------*
*
* MAGwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*        EMAC binary ΉD
*
*----------------------------------------------------------------------------*

header_read:
		lea.l	magwork(pc),a6
		bsr	getc
		cmp.b	#'M',d0
		bne	@f
		bsr	getc
		cmp.b	#'A',d0
		bne	@f
		bsr	getc
		cmp.b	#'K',d0
		bne	@f
		bsr	getc
		cmp.b	#'I',d0
		beq	mag_header_cont02
@@:
		move.w	#0,-(sp)
		pea.l	0.w
		move.w	_file(a5),-(sp)
		.dc.w	$FF42		* DOS	__SEEK
		addq.l	#8,sp
		bsr	skip_mac_binary
		bra	mag_header_cont

mag_header_read__
		bsr	skip_mac_binary
mag_header_cont
		lea.l	magwork(pc),a6
		moveq.l	#30,d6			* tH[}bgႢ
		bsr	getc
		cmp.b	#'M',d0
		bne	error_
		bsr	getc
		cmp.b	#'A',d0
		bne	error_
		bsr	getc
		cmp.b	#'K',d0
		bne	error_
		bsr	getc
		cmp.b	#'I',d0
		bne	error_
mag_header_cont02:
		moveq.l	#31,d6			* o[WႢ
		bsr	getc
		cmp.b	#'0',d0
		bne	error_
		bsr	getc
		cmp.b	#'2',d0
		bne	error_
		bsr	getc
		cmp.b	#' ',d0
		bne	error_
		bsr	getc
		cmp.b	#' ',d0
		bne	error_

		bsr	comment_get

		bsr	getc			* header
		bsr	getc			* machinecode
		bsr	getc			* machineflag
		bsr	getc			* screenmode

		move.w	#4,_color(a5)
		moveq.l	#32,d6
		btst.l	#7,d0
		beq	@f
		move.w	#8,_color(a5)		* 256
@@:		btst.l	#0,d0
		beq	@f
		st.b	_200flag(a5)
		move.b	#'!',_PP_flag(a5)
@@:
		bsr	getw			* X JnW
		rol.w	#8,d0
		move.w	d0,savesize(a6)
		bsr	getw			* Y JnW
		rol.w	#8,d0
		move.w	d0,savesize+2(a6)
		bsr	getw			* X IW
		rol.w	#8,d0
		move.w	d0,savesize+4(a6)
		bsr	getw			* Y IW
		rol.w	#8,d0
		move.w	d0,savesize+6(a6)

		clr.w	_1dot(a5)
		moveq.l	#31,d6
		tst.l	savesize+4(a6)
		bne	@f
		tst.l	savesize(a6)
		bne	@f
		st.b	_1dot(a5)
		bra	read_data
@@:
		move.w	savesize(a6),d0		* W̊ȒPȃ`FbN
		move.w	savesize+4(a6),d1
		cmp.w	d1,d0
		bhi	error_
		moveq.l	#31,d6
		move.w	savesize+2(a6),d0
		move.w	savesize+6(a6),d1
		cmp.w	d1,d0
		bhi	error_
		moveq.l	#33,d6
		move.w	savesize+4(a6),d1
		cmp.w	#3200-1,d1
		bhi	error_
		move.w	savesize+6(a6),d1
		cmp.w	#4096-1,d1
		bhi	error_
read_data:
		lea.l	flag_a_offs(a6),a0
		moveq.l	#3,d6			* ǂݍ݂Ɏs
		move.l	#palet-flag_a_offs,-(sp)
@@:		move.l	a0,-(sp)
		move.w	_file(a5),-(sp)
		DOS	_READ
		lea.l	10(sp),sp
		tst.l	d0
		bmi	error_

		moveq.l	#48,d0
		cmp.w	#8,_color(a5)
		bne	@f
		move.l	#256*3,d0
@@:		move.l	d0,-(sp)
		pea.l	_tmp(a5)
		move.w	_file(a5),-(sp)
		DOS	_READ
		lea.l	10(sp),sp
		tst.l	d0
		bmi	error_

		bsr	intel_l
		bsr	intel_l
		bsr	intel_l
		bsr	intel_l
		bsr	intel_l

		moveq.l	#31,d6
		btst.b	#0,flag_a_offs+3(a6)
		bne	error_
		btst.b	#0,flag_b_offs+3(a6)
		bne	error_
		btst.b	#0,pixel_offs+3(a6)
		bne	error_

		cmp.w	#8,_color(a5)
		beq	s256_1
		move.w	savesize(a6),d0
		move.w	savesize+4(a6),d1
		lsr.w	#3,d0
		lsr.w	#3,d1
		sub.w	d0,d1
		move.w	d1,xsize(a6)
		move.w	savesize+2(a6),d2
		move.w	savesize+6(a6),d1
		sub.w	d2,d1
		move.w	d1,ysize(a6)

		move.w	savesize(a6),d0
		and.w	#$fff8,d0
		move.w	d0,savesize(a6)
		move.w	d0,_scolum(a5)		* X JnW
		move.w	savesize+4(a6),d1
		and.w	#$fff8,d1
		addq.w	#7,d1
		move.w	d1,savesize+4(a6)
		move.w	d1,_ecolum(a5)		* X IW
		addq.w	#1,d1
		sub.w	d0,d1
		move.w	d1,_colum(a5)		* X SIZE
		ext.l	d1
		move.l	d1,xadd(a6)
		move.w	savesize+2(a6),d0
		move.w	d0,_sline(a5)
		move.w	savesize+6(a6),d1
		move.w	d1,_eline(a5)
		addq.w	#1,d1
		sub.w	d0,d1
		move.w	d1,_line(a5)

		bra	s_cont
s256_1:
	moveq.l	#0,d0			* uq`lItZbǧvZiQTUFj
	moveq.l	#0,d1
	moveq.l	#0,d2
	move.w	savesize(a6),d0
	move.w	savesize+4(a6),d1
	lsr.w	#2,d0
	lsr.w	#2,d1
	sub.w	d0,d1
	move.w	d1,xsize(a6)
	move.w	savesize+2(a6),d2
	move.w	savesize+6(a6),d1
	sub.w	d2,d1
	move.w	d1,ysize(a6)

		move.w	savesize(a6),d0
		and.w	#$fff8,d0
		move.w	d0,savesize(a6)
		move.w	d0,_scolum(a5)		* X JnW
		move.w	savesize+4(a6),d1
		and.w	#$fff8,d1
		addq.w	#7,d1
		move.w	d1,savesize+4(a6)
		move.w	d1,_ecolum(a5)		* X IW
		addq.w	#1,d1
		sub.w	d0,d1
		move.w	d1,_colum(a5)		* X SIZE
		ext.l	d1
		move.l	d1,xadd(a6)
		move.w	savesize+2(a6),d0
		move.w	d0,_sline(a5)
		move.w	savesize+6(a6),d1
		move.w	d1,_eline(a5)
		addq.w	#1,d1
		sub.w	d0,d1
		move.w	d1,_line(a5)


s_cont:

		bsr	setpalette

		moveq.l	#0,d0

		rts

error_:
		moveq.l	#-1,d0
		rts

intel_l:
	move.l	(a0),d0		* 1 2 3 4
	rol.w	#8,d0		* 1 2 4 3
	swap	d0		* 4 3 1 2
	rol.w	#8,d0		* 4 3 2 1
	move.l	d0,(a0)+
	rts


*----------------------------------------------------------------------------*
*  pbg擾
*----------------------------------------------------------------------------*

setpalette:
	tst.w	_palet(a5)
	bne	setpalette_end
	lea.l	_pal_buf(a5),a0
	lea.l	_tmp(a5),a1
	moveq.l	#15,d4
	cmp.w	#4,_color(a5)
	beq	setp00
	move.w	#255,d4
setp00:
	moveq.l	#0,d0
	move.l	d0,d1
	move.l	d0,d2
	move.b	(a1)+,d0
	move.b	(a1)+,d1
	move.b	(a1)+,d2
	lsl.w	#8,d0
	lsl.w	#3,d1
	lsr.w	#2,d2
	and.w	#%1111100000000000,d0
	and.w	#%0000011111000000,d1
	and.w	#%0000000000111110,d2
	or.w	d2,d0
	or.w	d1,d0
	move.w	d0,(a0)+
	dbra	d4,setp00
setpalette_end:
	rts


*----------------------------------------------------------------------------*
*
* 16/256摜WJC
*
*----------------------------------------------------------------------------*

pixel_decode:
	lea.l	flag(a6),a1		* a0 : flag WJp
	move.w	#256/4-1,d6
l_000:	move.l	#0,(a1)+		* flag WJobt@
	dbra	d6,l_000

	cmp.w	#8,_color(a5)
	bne	@f
	suba.l	#768-48,a0
@@:

	lea.l	(a0),a1
	add.l	pixel_offs(a6),a1	* a1 : pixel
	lea.l	(a0),a2
	adda.l	flag_a_offs(a6),a2	* a2 : flag a
	lea.l	(a0),a3
	adda.l	flag_b_offs(a6),a3	* a3 : flag b
	move.l	(a6),d4			* zVRAM

	cmp.w	#8,_color(a5)
	beq	pixel_decode_256

*----------------------------------------------------------------------------*
* zGRAMԂŃsNZRs[(16F)

	bsr	mk_table
	move.l	xadd(a6),d7

* ȌCa5͎gȂ.

	lea.l	cptbl11(pc),a5
	moveq.l	#0,d3			* rbgANZXJE^
	move.w	ysize(a6),d6
l_040:
	move.l	d4,a4
	lea.l	flag(a6),a0		* a0 : flag WJp
*---------------------------------------
	move.w	xsize(a6),d5
l_041:
	and.w	#%11111,d3
	bne	l_042
	move.l	(a2)+,d2		* SrbgOȂ flagA CNg
l_042:	subq.l	#1,d3
	btst.l	d3,d2
	beq	l_043
	move.b	(a3)+,d0
	eor.b	d0,(a0)
l_043:	move.b	(a0)+,d1		* d1 : tO

	move.b	d1,d0			* tOɂăRs[
	and.w	#%11110000,d0
	beq	pxcpy11
	lsr.w	#2,d0
	move.l	(a5,d0.w),d0
	move.l	(a4,d0.l),d0
	and.l	#%00001111_00001111_00001111_00001111,d0	* ͕̏KKv.ȉׂ.
	move.l	d0,(a4)+
jmpret01:
	and.w	#%00001111,d1
	beq	pxcpy12
	add.w	d1,d1			* lsl.w #2,d1
	add.w	d1,d1
	move.l	(a5,d1.w),d0
	move.l	(a4,d0.l),d0
	and.l	#%00001111_00001111_00001111_00001111,d0
	move.l	d0,(a4)+
jmpret02:
	dbra	d5,l_041

l_060:
	add.l	d7,d4
	dbra	d6,l_040

	rts

datset1	macro	dummy
	move.w	(a1)+,d0
	rol.w	#4,d0
	move.b	d0,(a4)+
	rol.w	#4,d0
	move.b	d0,(a4)+
	rol.w	#4,d0
	move.b	d0,(a4)+
	rol.w	#4,d0
	move.b	d0,(a4)+
	and.l	#%00001111_00001111_00001111_00001111,-4(a4)
	endm

pxcpy11	datset1
	bra	jmpret01
pxcpy12	datset1
	bra	jmpret02

*----------------------------------------------------------------------------*
* zGRAMԂŃsNZRs[(256F)

pixel_decode_256:
	bsr	mk_table256
	move.l	xadd(a6),d7

* ȌCa5͎gȂ.

	lea.l	cptbl11(pc),a5

	moveq.l	#0,d3			* rbgANZXJE^
	move.w	ysize(a6),d6
l_240:
	move.l	d4,a4
	lea.l	flag(a6),a0		* a0 : flag WJp
*-----------------------------------
	move.w	xsize(a6),d5
l_241:
	and.w	#%11111,d3
	bne	l_242
	move.l	(a2)+,d2
l_242:	subq.l	#1,d3
	btst.l	d3,d2
	beq	l_243
	move.b	(a3)+,d0
	eor.b	d0,(a0)
l_243:	move.b	(a0)+,d1		* d1 : tO

	move.b	d1,d0			* tOɂăRs[
	and.w	#%11110000,d0
	beq	pxcpy21
	lsr.w	#2,d0
	move.l	(a5,d0.w),d0
	move.l	(a4,d0.l),d0
	swap.w	d0
	move.w	d0,(a4)+
jmpret21:
	and.w	#%00001111,d1
	beq	pxcpy22
	add.w	d1,d1			* lsl.w #2,d1
	add.w	d1,d1
	move.l	(a5,d1.w),d0
	move.l	(a4,d0.l),d0
	swap.w	d0
	move.w	d0,(a4)+
jmpret22:
	dbra	d5,l_241
	add.l	d7,d4
	dbra	d6,l_240

	rts

datset2	macro	dummy
	move.b	(a1)+,(a4)+
	move.b	(a1)+,(a4)+
	endm

pxcpy21	datset2
	bra	jmpret21
pxcpy22	datset2
	bra	jmpret22


*----------------------------------------------------------------------------*
* e[u쐬

mk_table:
	lea.l	cptbl11(pc),a0
	moveq.l	#0,d7
	move.w	_colum(a5),d7

	move.l	#-0*4,d2
	move.l	d2,(a0)+
	move.l	#-1*4,d2
	move.l	d2,(a0)+
	move.l	#-2*4,d2
	move.l	d2,(a0)+
	move.l	#-4*4,d2
	move.l	d2,(a0)+

	move.l	#-0*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-2*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-2*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-2*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*4,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	rts

mk_table256:
	lea.l	cptbl11(pc),a0
	moveq.l	#0,d7
	move.w	_colum(a5),d7

	move.l	#-0*2,d2
	move.l	d2,(a0)+
	move.l	#-1*2,d2
	move.l	d2,(a0)+
	move.l	#-2*2,d2
	move.l	d2,(a0)+
	move.l	#-4*2,d2
	move.l	d2,(a0)+

	move.l	#-0*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-2*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-2*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-1*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	move.l	#-2*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+

	add.l	d7,d7

	move.l	#-0*2,d2
	sub.l	d7,d2
	move.l	d2,(a0)+
	rts


*----------------------------------------------------------------------------*
* Rs[p΃AhXe[u

	.even
cptbl11	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0


*----------------------------------------------------------------------------*
* ItZbg

	.offset 0
worktop:	ds.l	1
xsize:		ds.w	1
ysize:		ds.w	1
xadd:		.ds.l	1
flag:		ds.b	256

header:		ds.b	1		* `FbNf[^
machinecode:	ds.b	1		* }VR[h
machineflag:	ds.b	1		* @ˑtO
screenmode:	ds.b	1		* [htO
savesize:	ds.w	4		* x1,y1,x2,y2
flag_a_offs:	ds.l	1		* flag_a offset
flag_b_offs:	ds.l	1		* flag_b offset
flag_b_size:	ds.l	1		* flag_b size
pixel_offs:	ds.l	1		* pixel  offset
pixel_size:	ds.l	1		* pixel  size
palet:		ds.b	48
		.even
workend:

		.text


*----------------------------------------------------------------------------*
* [NGA

magwork:
	.ds.b	workend
	.even

		.end
