		.title	MPH3 Library routine. written by Herzen

* mph.h KvƂȂ[`Q


* Include File -------------------------------- *

		.include	mph_lib.h
		.include	doscall.mac
		.include	iocscall.mac


* Fixed Number -------------------------------- *

BEL:		.equ	$07
TAB:		.equ	$09
LF:		.equ	$0a
CR:		.equ	$0d
EOF:		.equ	$1a


* I/O Port ------------------------------------ *

GVRAM:		.equ	$c00000
GVRAM_END:	.equ	$e00000
GVRAM256P0_END:	.equ	$c80000
TVRAM:		.equ	$e00000
TVRAM_END:	.equ	$e80000

CRTC_R21:	.equ	$e8002a
CRTC_R22:	.equ	$e8002c
CRTC_R23:	.equ	$e8002e
CRTC_ACT:	.equ	$e80481

MFP_GPIP:	.equ	$e88001


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

to_super::
		move.l	(sp),-(sp)
		move.l	d0,-(sp)
		clr.l	-(sp)
		DOS	_SUPER
		addq.l	#4,sp
		move.l	d0,(8,sp)
		move.l	(sp)+,d0
		rts

to_user::
		move.l	d0,-(sp)
		move.l	(8,sp),-(sp)
		DOS	_SUPER
		addq.l	#4,sp
		move.l	(sp)+,d0
		move.l	(sp)+,(sp)
		rts

	.ifdef	__DEBUG__
debug:
		movem.l	d0-d1,-(sp)
		moveq	#BEL,d1
		IOCS	_B_PUTC
		movem.l	(sp)+,d0-d1
		rts
	.endif

icrlf:
		movem.l	d0-d1,-(sp)
	.ifdef	__CRLF__
		moveq	#CR,d1
		IOCS	_B_PUTC
	.endif
		moveq	#LF,d1
		IOCS	_B_PUTC
		movem.l	(sp)+,d0-d1
		rts

crlf:
		move.l	d0,-(sp)
	.ifdef	__CRLF__
		move	#CR,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
	.endif
		move	#LF,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
		move.l	(sp)+,d0
		rts

key_flush:
		move.l	d0,-(sp)
		clr	-(sp)
		DOS	_KFLUSH
		addq.l	#2,sp
		move.l	(sp)+,d0
		rts

strcpy:
		move.b	(a1)+,(a0)+
		bne	strcpy
		subq.l	#1,a0
		rts

@@:
		move.b	d0,(a0)+
strcpy_to_eof::
		move.b	(a1)+,d0
		beq	@f
		cmpi.b	#EOF,d0
		bne	@b
@@:
		clr.b	(a0)
		rts

@@:
		move.b	d0,(a0)+
strcpy_to_return::
		move.b	(a1)+,d0
		beq	@f
		cmpi.b	#CR,d0
		beq	@f
		cmpi.b	#LF,d0
		beq	@f
		cmpi.b	#EOF,d0
		bne	@b
@@:
		clr.b	(a0)
		rts

strchk::
		move.l	a0,-(sp)
		move.b	-(a0),d0
		bpl	ank		;$00-$7f
		cmpi.b	#$a0,d0
		bcs	kanji
		cmpi.b	#$e0,d0
		bcs	ank
kanji:
		moveq	#-1,d0
		bra	strchk_end
ank:
		moveq	#0,d0
strchk_end:
		movea.l	(sp)+,a0
		rts


*------------------------------------------------------------------------------*
*  16FpbgRGBϊ
*
*  in : a0   = ̓pbg
*       a1   = oRGB
*
*	񋟁Cfrom Ztome
*	rewrited by Herzen.
*	rewrited by Ԃ
*

get_rgb::
		movem.l	d0-d4/a0-a1,-(sp)
		moveq	#16-1,d4	* d3.l = loop counter 16 colors -1
getpal1:
		move	(a0)+,d0	* d2.l = palette code

		lsr	#2,d0
		moveq	#$0f,d1
		and	d0,d1		* d1.b = Blue

		lsr	#5,d0
		moveq	#$0f,d2
		and	d0,d2		* d2.b = Red

		lsr	#5,d0
*		moveq	#$0f,d3
*		and	d0,d3		* d0.b = Green

		move.b	d2,(a1)+	* palette buffer written
		move.b	d0,(a1)+
		move.b	d1,(a1)+
		dbra	d4,getpal1

		movem.l	(sp)+,d0-d4/a0-a1
		rts

*------------------------------------------------------------------------------*
*  RGB16Fpbgϊ
*
*  in : a0   = RGB
*       a1   = o̓pbg
*
*	񋟁Cfrom Ztome
*	rewrited by Herzen.
*	rewrited by Ԃ
*

set_rgb::
		movem.l	d0-d4/a0-a1,-(sp)

		moveq	#16-1,d4	* d3.l = loop counter 16 colors -1
		moveq	#12,d0
setpal1:
		moveq	#$0f,d1
		move.w	d1,d2
		move.w	d1,d3
		and.b	(a1)+,d1	* d1.b = Red
		and.b	(a1)+,d2	* d2.b = Green
		and.b	(a1)+,d3	* d3.b = Blue

		lsl	#7,d1
		lsl	d0,d2		;lsl #12,d2
		lsl	#2,d3

		or	d2,d1
		or	d3,d1		* d2.l = palette code %xxxx_0xxx_x0xx_xx00

*		tst	d1		* pbg͍H
		beq	setpal2		* ͂Ȃ

		ori	#%00001_00001_00001_0,d1
setpal2:
		move	d1,(a0)+
		dbra	d4,setpal1
		movem.l	(sp)+,d0-d4/a0-a1
		rts


*------------------------------------------------------------------------------*
*  Z[uoߕ
*
*  in : d0.w = chbg
*     : d1.w = c̏chbg
*
* y_buff  d0. 400
* y_width d1. 400,,,1

line_disp:
		movem.l	d2/a1,-(sp)
		cmp.w	d0,d1
		beq	@f
		bhi	line_disp_xx
		move.w	d1,d2
		and.w	#$0f,d2
		bne	line_disp_end
@@:
		tst.w	d1
		beq	line_disp_xx
		move.w	d0,d2		* ޔ
		beq	line_disp_end

		sub.w	d1,d0
		move.w	d0,d1		* 400,,,1  1,,,400
		ext.l	d1
		mulu.w	#100,d1
		divu.w	d2,d1
		and.l	#$0000ffff,d1
		cmp.w	#100,d1
		bcc	line_disp_xx

		lea.l	-20(sp),sp
		movea.l	sp,a1

		divu.w	#10,d1
		add.l	#$00300030,d1
		move.b	#' ',(a1)+
		move.b	#' ',(a1)+
line_disp_main:
		move.b	d1,(a1)+
		swap.w	d1
		move.b	d1,(a1)+
		move.b	#'%',(a1)+
		moveq.l	#8,d1
	.rept	5
		move.b	d1,(a1)+
	.endm
		clr.b	(a1)
		movea.l	sp,a1
		IOCS	_B_PRINT
		lea.l	20(sp),sp
line_disp_end:
		movem.l	(sp)+,d2/a1
		rts

line_disp_x:
		movem.l	d2/a1,-(sp)
line_disp_xx:
		lea.l	-20(sp),sp
		movea.l	sp,a1
		move.b	#' ',(a1)+
		move.b	#'1',(a1)+
		move.l	#'0'<<16+'0',d1
		bra	line_disp_main

*------------------------------------------------------------------------------*
*  I[gNbsO(16F)
*
*  in : d1.w = rWACtH()  0:Ȃ  1:
*  out: d0.l = () _scolum
*              () _ecolum
*       d1.l = () _sline
*              () _eline

* ̗]n͏\邯ǁCʓ|炱ł :-)

clipping:
	movem.l	d2-d5/a0-a1,-(sp)
	move.w	d1,d6
	moveq.l	#0,d0
	moveq.l	#0,d1

scolum_search:				* Start X

	lea	(GVRAM),a1
	move	#1024-1,d4
sx_out:
	moveq.l	#1024/16-1,d5
	movea.l	a1,a0
sx_in:
	bsr	y_chk
	bne	scolum_end
	adda.l	#2048*16,a0
	dbra	d5,sx_in
	addq.l	#2,a1
	addq.w	#1,d0
	bsr	y_disp
	dbra	d4,sx_out
scolum_end:

	lea.l	txy_dat(pc),a1
	move.w	#1023,2(a1)
	move.w	#$ffff,8(a1)
	lea.l	txx_dat(pc),a1

	cmp.w	#1024,d0
	bne	@f
	moveq.l	#0,d0
	move.w	d0,2(a1)
	bra	sline_search
@@:
	move.w	d0,2(a1)
	swap.w	d0

ecolum_search:				* End X

	move	#1023,d0
	lea	(GVRAM+2048-2),a1
	move	#1024-1,d4
ex_out:
	moveq.l	#1024/16-1,d5
	movea.l	a1,a0
ex_in:
	bsr	y_chk
	bne	ecolum_end
	adda.l	#2048*16,a0
	dbra	d5,ex_in
	subq.l	#2,a1
	subq.w	#1,d0
	bsr	y_disp
	dbra	d4,ex_out
ecolum_end:

sline_search:				* Start Y

	lea.l	txx_dat(pc),a1
	move.w	2(a1),d4
	move.w	d0,d5
	sub.w	d4,d5
	addq.w	#1,d5
	move.w	d5,6(a1)

	lea	(GVRAM),a0
	move	#1024-1,d4
sy_out:
	move	#1024-1,d5
sy_in:
	tst	(a0)+
	dbne	d5,sy_in
	bne	sline_end
	addq	#1,d1
	bsr	x_disp
	dbra	d4,sy_out
sline_end:
	cmp.w	#1024,d1
	bne	@f
	moveq.l	#0,d1
	bra	eline_end
@@:
	swap.w	d1

	lea.l	txx_dat(pc),a1
	move.w	#1023,4(a1)
	move.w	#$ffff,8(a1)

eline_search:				* End Y

	move	#1023,d1
	lea	(GVRAM_END),a0
	move	#1024-1,d4		;y loop
ey_out:
	move	#1024-1,d5		;x loop
ey_in:
	tst	-(a0)
	dbne	d5,ey_in
	bne	eline_end
	subq	#1,d1
	bsr	x_disp
	dbra	d4,ey_out
eline_end:

	movem.l	(sp)+,d2-d5/a0-a1
	rts

y_disp:
	tst	d6
	beq	@f
	movem.l	d0-d1/a1,-(sp)
	move	d0,d1
	lea	(txy_dat,pc),a1
	clr	(8,a1)
	IOCS	_TXYLINE
	move	#$ffff,(8,a1)
	move	d1,(2,a1)
	IOCS	_TXYLINE
	movem.l	(sp)+,d0-d1/a1
@@:	rts

txy_dat:
	.dc.w	2
	.dc.w	0
	.dc.w	0
	.dc.w	16*31
	.dc.w	$FFFF

x_disp:
	tst	d6
	beq	@f
	movem.l	d0-d1/a1,-(sp)
	lea	(txx_dat,pc),a1
	clr	(8,a1)
	IOCS	_TXXLINE
	move	#$ffff,(8,a1)
	move	d1,(4,a1)
	IOCS	_TXXLINE
	movem.l	(sp)+,d0-d1/a1
@@:	rts

txx_dat:
	.dc.w	2
	.dc.w	0
	.dc.w	0
	.dc.w	8*96
	.dc.w	$FFFF

y_chk:
	i:=0
	.rept	15
		tst.w	2048*i(a0)
		bne	@f
		i:=i+1
	.endm
		tst.w	2048*i(a0)
@@:
		rts

*	tst.w	2048*0(a0)
*	bne	@f
*	
*	
*	
*	tst.w	2048*15(a0)
*	bne	@f
**@@:	rts

*------------------------------------------------------------------------------*
*  I[gNbsOT[`(256F)
*
*  in : d1.w = rWACtH()  0:Ȃ  1:
*  out: d0.l = () _scolum
*              () _ecolum
*       d1.l = () _sline
*              () _eline

clipping256:
	movem.l	d2-d5/a0-a1,-(sp)
	move.w	d1,d6
	moveq.l	#0,d0
	moveq.l	#0,d1

scolum_search256:				* Start X

	lea	(GVRAM),a1
	move	#512-1,d4
sx_out256:
	moveq	#512/16-1,d5
	movea.l	a1,a0
sx_in256:
	bsr	y_chk256
	bne	scolum_end256
	adda.l	#1024*16,a0
	dbra	d5,sx_in256
	addq.l	#2,a1
	addq.w	#1,d0
	bsr	y_disp
	dbra	d4,sx_out256
scolum_end256:

	lea.l	txy_dat(pc),a1
	move.w	#511,2(a1)
	move.w	#$ffff,8(a1)
	lea.l	txx_dat(pc),a1

	cmp.w	#512,d0
	bne	@f
	moveq.l	#0,d0
	move.w	d0,2(a1)
	bra	sline_search256
@@:
	move.w	d0,2(a1)
	swap.w	d0

ecolum_search256:				* End X

	move	#511,d0
	lea	(GVRAM+1024-2),a1
	move	#512-1,d4
ex_out256:
	moveq	#512/16-1,d5
	movea.l	a1,a0
ex_in256:
	bsr	y_chk256
	bne	ecolum_end256
	adda.l	#1024*16,a0
	dbra	d5,ex_in256
	subq.l	#2,a1
	subq.w	#1,d0
	bsr	y_disp
	dbra	d4,ex_out256
ecolum_end256:

sline_search256:				* Start Y

	lea.l	txx_dat(pc),a1
	move.w	2(a1),d4
	move.w	d0,d5
	sub.w	d4,d5
	addq.w	#1,d5
	move.w	d5,6(a1)

	lea	(GVRAM),a0
	move	#512-1,d4
sy_out256:
	move	#512-1,d5
sy_in256:
	tst	(a0)+
	dbne	d5,sy_in256
	bne	sline_end256
	addq	#1,d1
	bsr	x_disp
	dbra	d4,sy_out256
sline_end256:
	cmp.w	#512,d1
	bne	@f
	moveq.l	#0,d1
	bra	eline_end256
@@:
	swap.w	d1

	lea.l	txx_dat(pc),a1
	move.w	#511,4(a1)
	move.w	#$ffff,8(a1)

eline_search256:				* End Y

	move	#511,d1
	lea	(GVRAM256P0_END),a0
	move	#511-1,d4
ey_out256:
	move	#511-1,d5
ey_in256:
	tst	-(a0)
	dbne	d5,ey_in256
	bne	eline_end256
	subq	#1,d1
	bsr	x_disp
	dbra	d4,ey_out256
eline_end256:

	movem.l	(sp)+,d2-d5/a0-a1
	rts


y_chk256:
	i:=0
	.rept	15
		tst.w	1024*i(a0)
		bne	@f
		i:=i+1
	.endm
		tst.w	1024*i(a0)
@@:
		rts

*------------------------------------------------------------------------------*
*  I[gNbsOi16/256zGRAMj
*
*  in : a0.l = zGRAMAhX
*       d0.w = _colum
*       d1.w = _line
*  out: d0.l = () StartX    * ܂łzGRAM̍WłC
*              () EndX      * WƂ͈قȂD
*       d1.l = () StartY    * V_scolum = StartX + _scolum
*              () EndY

clipping_vs:
	movem.l	d2-d7/a0-a2,-(sp)
	movea.l	a0,a2
	move.w	d0,d6  * XS
	move.w	d1,d7  * YS

	moveq.l	#0,d0
	move.l	d0,d1

sx_vs:					* Start X
	movea.l	a2,a1
	move.w	d6,d5
	subq.w	#1,d5
sx_lop
	movea.l	a1,a0
	bsr	y_chk_vs
	bne	@f
	addq.l	#1,a1
	addq.w	#1,d0
	dbra	d5,sx_lop
@@:

	cmp.w	d6,d0
	bne	@f
	moveq.l	#0,d0
	bra	sy_vs
@@:
	swap.w	d0

ex_vs:					* End X
	move.w	d6,d0
	subq.w	#1,d0

	lea.l	(a2,d6.w),a1
	subq.l	#1,a1
	move.w	d6,d5
	subq.w	#1,d5
ex_lop:
	movea.l	a1,a0
	bsr	y_chk_vs
	bne	@f
	subq.l	#1,a1
	subq.w	#1,d0
	dbra	d5,ex_lop
@@:

sy_vs:					* Start Y

	movea.l	a2,a0
	move.w	d7,d4
	subq.w	#1,d4
sy_lop:
	move.w	d6,d5
	subq.w	#1,d5
@@:	tst.b	(a0)+
	bne	@f
	dbra	d5,@b
	addq.w	#1,d1
	dbra	d4,sy_lop
@@:

	cmp.w	d7,d1
	bne	@f
	moveq.l	#0,d1
	bra	clip_vs_end
@@:
	swap.w	d1

ey_vs:					* End Y

	move.w	d7,d1
	subq.w	#1,d1

	move.w	d6,d2
	mulu.w	d1,d2

	lea.l	(a2,d2.l),a1
	move.w	d7,d4
	subq.w	#1,d4
ey_lop:
	movea.l	a1,a0
	move.w	d6,d5
	subq.w	#1,d5
@@:	tst.b	(a0)+
	bne	@f
	dbra	d5,@b
	subq.w	#1,d1
	suba.w	d6,a1
	dbra	d4,ey_lop
@@:

clip_vs_end:
	movem.l	(sp)+,d2-d7/a0-a2
	rts

y_chk_vs:
	move.w	d7,d2	* Y SIZE
	subq.w	#1,d2
@@:	tst.b	(a0)
	bne	@f
	lea.l	(a0,d6.w),a0
	dbra	d2,@b
	moveq.l	#0,d2		* CCR  ZtO𗧂Ă
@@:	rts

*------------------------------------------------------------------------------*
*  `؂oi16/256zGRAMj
*
*  in : a0.l = zGRAMAhX
*       a1.l = `f[^̕ۑꏊ̃AhX
*       d0.l = () StartX
*              () EndX
*       d1.l = () StartY
*              () EndY
*       d2.w = _colum

rectangle_cut:
	movem.l	d0-d7/a0-a2,-(sp)
	move.l	d0,d6
	move.l	d1,d7

	swap.w	d0
	swap.w	d1

	sub.w	d0,d6			* `XSIZE
	sub.w	d1,d7			* `YSIZE
	addq.w	#1,d6
	addq.w	#1,d7

	mulu.w	d2,d1
	ext.l	d0
	add.l	d0,d1			* `Jnʒu
	lea.l	(a0,d1.l),a2
**	movea.l	a1,a4

	subq.w	#1,d7
rc_lop:
	movea.l	a2,a0
**	movea.l	a4,a1
	move.w	d6,d0
	subq.w	#1,d0
@@:	move.b	(a0)+,(a1)+
	dbra	d0,@b
	lea.l	(a2,d2.w),a2
**	lea.l	(a4,d2.w),a4
	dbra	d7,rc_lop

	movem.l	(sp)+,d0-d7/a0-a2
	rts

*------------------------------------------------------------------------------*
*  nCXs[heLXgNA[`
*
*	񋟁Cfrom H.ATA
*

	.if	0
HT_CLR::
		movem.l	d0-d1/a0,-(sp)
		lea	(TVRAM),a0
		move	(CRTC_R21),-(sp)	* ݒL
		move	#$03ff,(CRTC_R21)	* }XNItEANZXgp
		clr	(CRTC_R23)		* }XNNA
		moveq	#0,d0
		moveq	#$80/4*4-1,d1
@@:		move.l	d0,(a0)+		* 4line ݂ŃNA
		dbra	d1,@b

		moveq	#1,d0

		move	#256-1-1,d1
ht_clr_loop:
@@:		tst.b	(MFP_GPIP)
		bmi	@b
@@:		tst.b	(MFP_GPIP)
		bpl	@b

		move	d0,(CRTC_R22)		* X^w
		bset.b	#3,(CRTC_ACT)		* X^Rs[Jn
		addq	#1,d0
		dbra	d1,ht_clr_loop

@@:		tst.b	(MFP_GPIP)		*܂X^Rs[s
		bmi	@b
@@:		tst.b	(MFP_GPIP)
		bpl	@b

		bclr.b	#3,(CRTC_ACT)
		move	(sp)+,(CRTC_R21)
		movem.l	(sp)+,d0-d1/a0
		rts
	.endif

*------------------------------------------------------------------------------*
*  TVRAMNA[`

tvram_clear:
		movem.l	d1-d7/a0-a6,-(sp)
		moveq	#0,d0
	.irp	reg,d1,d2,d3,d4,d5,d6,a0,a1,a2,a3,a4,a5
		move.l	d0,reg
	.endm
		lea	(TVRAM_END),a6
		move	#$40000/(4*13),d7
@@:
		movem.l	d0-d6/a0-a5,-(a6)
		dbra	d7,@b

		movem.l	(sp)+,d1-d7/a0-a6
		rts

*------------------------------------------------------------------------------*
*  unsigned 10iϊ
*
*  in : a0.l = ރobt@AhX
*       d0.l = ϊl
*       d1.w = ő包
*       d2.w = 0:ʏ           => "  128"
*              1:Xy[Xt]   => "128  "
*              2:Xy[XJbg => "128"
*
*	QlCloquat.has by TAMA.
*

LTOS:
	link	a6,#-16
	movem.l	d1-d3/d6-d7/a1-a2/a6,-(sp)

	move.l	a0,a2
	move.w	d2,d7
	move.w	d1,d6

	lea.l	-16(a6),a0

	lea.l	table_l(pc),a1
	moveq.l	#9-1,d1			*loop counter
soto_loop:
	move.l	(a1)+,d2
	moveq.l	#'0',d3			*character code
naka_loop:
	sub.l	d2,d0
	bcs	next_column
	addq.b	#1,d3
	bra	naka_loop
next_column:
	add.l	d2,d0
	move.b	d3,(a0)+
	dbra	d1,soto_loop

	addi.b	#'0',d0
	move.b	d0,(a0)+		*to string buffer
	clr.b	(a0)			*end code

	lea.l	-10(a0),a0
	moveq.l	#9-1,d2			*loop counter
space_loop:
	cmpi.b	#'0',(a0)
	bne	LTOS_exit
	move.b	#' ',(a0)+
	dbra	d2,space_loop
LTOS_exit:

	cmp.w	#2,d7
	bne	rev_space

	lea.l	-16(a6),a0
	move.w	#10,d0 
	sub.w	d6,d0
	add.w	d0,a0
@@:	cmp.b	#' ',(a0)+
	beq	@b
	subq.l	#1,a0
@@:
	move.b	(a0)+,d0
	beq	LTOS_EXIT
	move.b	d0,(a2)+
	bra	@b

rev_space:
	cmp.w	#1,d7
	bne	space

	lea.l	-16(a6),a0
	move.w	#10,d0 
	sub.w	d6,d0
	add.w	d0,a0
	moveq.l	#0,d1
@@:	cmp.b	#' ',(a0)
	bne	@f
	addq.l	#1,a0
	addq.w	#1,d1
	bra	@b
@@:
	move.b	(a0)+,d0
	beq	@f
	move.b	d0,(a2)+
	bra	@b
@@:
	subq.w	#1,d1
	bmi	LTOS_EXIT
@@:	move.b	#' ',(a2)+
	dbra	d1,@b
	bra	LTOS_EXIT

space:
	lea.l	-16(a6),a0
	move.w	#10,d0 
	sub.w	d6,d0
	add.w	d0,a0
@@:
	move.b	(a0)+,d0
	beq	LTOS_EXIT
	move.b	d0,(a2)+
	bra	@b

LTOS_EXIT:
	move.l	a2,a0
	movem.l	(sp)+,d1-d3/d6-d7/a1-a2/a6
	unlk	a6
	rts

table_l:
	dc.l	1000000000
	dc.l	100000000
	dc.l	10000000
	dc.l	1000000
	dc.l	100000
	dc.l	10000
	dc.l	1000
	dc.l	100
	dc.l	10

*------------------------------------------------------------------------------*

prtdec:
	link	a3,#-8
	movem.l	d0-d1/a0-a3,-(sp)

	and.l	#$0000ffff,d0
	lea.l	-8(a3),a0
	clr	(6,a0)
	addq.l	#6,a0
	moveq.l	#5-1,d1
prtdec0:
	divu.w	#10,d0
	swap.w	d0
	addi.w	#'0',d0
	move.b	d0,-(a0)
	clr.w	d0
	swap.w	d0
	dbeq	d1,prtdec0
@@:
	move.b	#' ',-(a0)
	dbra	d1,@b
pdis:
	move.l	a0,-(sp)
	DOS	_PRINT
	addq.l	#4,sp

	movem.l	(sp)+,d0-d1/a0-a3
	unlk	a3
	rts

*------------------------------------------------------------------------------*

child:
	link	a6,#-520
	movem.l	d1-d7/a0-a6,-(sp)
	lea.l	-516(a6),a0
	move.w	#255-1,d0
@@:	move.b	(a1)+,(a0)+
	dbeq	d0,@b
	subq.l	#1,a0
	move.b	#$20,(a0)+
@@:	move.b	(a2)+,(a0)+
	dbeq	d0,@b
	clr.b	(a0)
	pea.l	0.w
	pea.l	-256(a6)
	pea.l	-516(a6)
	move.w	#2,-(sp)
	DOS	_EXEC
	tst.l	d0
	bmi	chld1
	clr	(sp)
	DOS	_EXEC
chld1:	lea	14(sp),sp
	movem.l	(sp)+,d1-d7/a0-a6
	unlk	a6
	rts

*------------------------------------------------------------------------------*
*	QlChexout.s by ~g

HEXOUT:
	link	a6,#-10
	movem.l	d0-d2/a0-a1,-(sp)
	lea.l	-10(a6),a0
	clr.l	(a0)+
	clr.l	(a0)+
	clr.w	(a0)
	lea.l	-10(a6),a0
	lea.l	hextrans_dat(pc),a1
	moveq.l	#8-1,d2
hex_lop:
	rol.l	#4,d0
	moveq.l	#%1111,d1
	and.b	d0,d1
	move.b	0(a1,d1.w),(a0)+
	dbra	d2,hex_lop
	pea.l	-10(a6)
	DOS	_PRINT
	addq.l	#4,sp
	bsr	crlf
	movem.l	(sp)+,d0-d2/a0-a1
	unlk	a6
	rts
hextrans_dat:
	.dc.b	'0123456789ABCDEF'


		.end

* End of File --------------------------------- *
